/** Defines the about dialog for Xxy.
 *  uses ClPoser for poser logo fading
 *
 *
 *  @author Vitus Lorenz-Meyer
 *  @version 1.0 $Rev$
 */

package Control;
import util.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


class ClAboutDialog extends JDialog{
	/** Authors */
	static final String msAuthors = "Vitus Lorenz-Meyer, Jan Sonnenberg, Philipp Kaluza,\nJanosch Kalateh, Martin Berndt, Stefan Krause";

	/** returns the localized String - only for convenience so that _("string") works within this class */
        private static String _(String pstrGid){ return gnu.gettext.GettextResource.gettext(Control.ClXxy.moResBundle,pstrGid); }

	/** Constructor of the about dialog
	 *  @param pParent - Parent Frame, needed for a modal dialog
	 *  @throws an XXYError if about.png could'nt be found*/
	public ClAboutDialog(Frame pParent) throws EXXYError{
		super(pParent,_("About..."),true);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setResizable( false );

		//main panel
		JPanel pane = new JPanel(new BorderLayout());

		JPanel pane2 = new JPanel(new BorderLayout());
		//fading pic
		ClPoser myPoser = null;
		try{ myPoser = new ClPoser(4,36); }
		catch(Exception e){ throw new EInternalError(_("Xxy logo could'nt be found")); }
		myPoser.setBorder(BorderFactory.createEmptyBorder(10,10,5,10));
		pane2.add(myPoser,BorderLayout.NORTH);

		//Version
		JLabel VerLabel=new JLabel(ClXxy.mstrVersion,JLabel.CENTER);
		VerLabel.setBorder(BorderFactory.createEmptyBorder(0,10,10,10));
		pane2.add(VerLabel,BorderLayout.CENTER);

		pane.add(pane2,BorderLayout.NORTH);

		//authors
		pane2 = new JPanel(new FlowLayout());
		pane2.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		JTextArea ta = new JTextArea(msAuthors);
		ta.setBorder(BorderFactory.createEtchedBorder());
		ta.setEditable( false );
		ta.setFont(new Font("Serif",Font.BOLD,12));
		pane2.add(ta);
		pane.add(pane2);

		//OK button
		JButton myButton = new JButton(_("whatever"));
		myButton.addActionListener(new ActionListener() {
           		public void actionPerformed(ActionEvent e) {
                		dispose();
            		}
        	});

		pane2 = new JPanel(new FlowLayout());
		pane2.setBorder(BorderFactory.createEmptyBorder(0,0,0,5));
		pane2.add(myButton);
		pane.add(pane2,BorderLayout.SOUTH);

		//add the pane to the frame
		getContentPane().add(pane);
		pack();
		//set the location to the center of parent
		setLocation((pParent.getSize().width/2)-(getSize().width/2),(pParent.getSize().height/2)-(getSize().height/2));
		//shows the dialog
		show();
	}

}
