/** Interface that defines how the Data Abstraction Layer (DAL) represents a
 *  Label to the outside world.
 *
 *  @Author Philipp Kaluza
 *  @Version 1.0 $Rev: 244 $
 */
// $Id: ILabel.java 244 2003-05-25 15:15:01Z phk $

package DAL;

import util.*;

public interface ILabel {
	/** get the label's position within it's parent diagram
	 *  @return the logical position as ClCoord */
	ClCoord	getPos();

	/** move the label to a different position within it's parent diagram
	 *  @param pkPos the new anchor position */
	void	setPos(ClCoord pkPos) throws EXXYError;


	/** get the label's caption
	 *  @return the label's caption */
	String	getCaption();

	/** set the label's caption
	 *  @param pstrCaption the label's new caption */
	void	setCaption(String pstrCaption);


	/** get all the arrows originating from this label
	 *  @return an Iterator over these arrows */
	java.util.Iterator	getArrowIterator();


	/** unlink and destroy this label */
	void	remove() throws EXXYError;
}
