/** Class that represents a Diagram as defined by IDiagram
 *
 *  @Author Philipp Kaluza
 *  @Version 1.0 $Rev$
 */
// $Id$

package DAL.Simple;

import util.*;
import DAL.*;

import java.util.Map;
import java.util.Iterator;
import java.util.Hashtable;

public class ClDiagram implements IDiagram {
	private	String	mstrFilename;
	private	Map	moLabels;
	private boolean	mbDirty;

	public ClDiagram() {
		mstrFilename	= "";
		moLabels	= new Hashtable();
		mbDirty		= false;
	}
	public ClDiagram(String s) {
		this();
	}
	public String getFilename() {
		return mstrFilename;
	}

	public void setFilename(String pstrFilename) {
		mstrFilename = pstrFilename;
	}

	public ILabel addNewLabel(ClCoord kPos) throws EXXYError {
		return new ClLabel(this, kPos);
	}

	public IArrow addNewArrow(ClCoord kBase, ClCoord kTarget) throws EXXYError {
		return new ClArrow(this, kBase, kTarget);
	}

	public boolean getDirty() {
		return mbDirty;
	}

	public void setDirty(boolean pbDirty) {
		mbDirty = pbDirty;
	}

	public ILabel getLabelAtPos(ClCoord pkPos) {
		return (ClLabel) (moLabels.get(pkPos));
	}

	public Iterator getLabelIterator() {
		return moLabels.values().iterator();
	}

	public void remove() {
		// TODO
	}

	///////////////////////////////////////////////////////////////////////

	protected void regLabel(ClLabel poLabel) throws ESyntacticError {
		ClCoord kPos = poLabel.getPos();

		if (moLabels.containsKey(kPos)) {
			throw new ESyntacticError("Already a label there !");
		} else {
			moLabels.put(kPos, poLabel);
		}
	}

	protected void unregLabel(ClLabel poLabel) throws EInternalError {
		ClCoord kPos	= poLabel.getPos();
		ClLabel oLabel	= (ClLabel) (moLabels.get(kPos));

		if (oLabel != poLabel) {
			throw new EInternalError("trying to delete wrong label !");
		}
		moLabels.remove(kPos);
	}
}
