/** Class that represents a Label as defined by ILabel
 *
 *  @Author Philipp Kaluza
 *  @Version 1.0 $Rev: 244 $
 */
// $Id: ClLabel.java 244 2003-05-25 15:15:01Z phk $

package DAL.Simple;

import util.*;
import DAL.*;
import java.util.Vector;
import java.util.Iterator;

public class ClLabel implements DAL.ILabel {
	private ClDiagram	moParent;
	private ClCoord		mkPos;
	private String		mstrCaption;

	private Vector		moOriginatingArrows;
	private Vector		moEndingArrows;

	ClLabel(IDiagram poParent, ClCoord pkPos) throws EXXYError {
		moParent    = (ClDiagram) poParent;
		mkPos       = pkPos;
		mstrCaption = "";

		moOriginatingArrows	= new Vector();
		moEndingArrows		= new Vector();

		moParent.regLabel(this);
	}

	public ClCoord getPos() {
		return mkPos;
	}

	public void setPos(ClCoord pkPos) throws EXXYError {
		moParent.unregLabel(this);
		mkPos = pkPos;
		moParent.regLabel(this);
	}

	public String getCaption() {
		return mstrCaption;
	}

	public void setCaption(String pstrCaption) {
		mstrCaption = pstrCaption;
	}

	public Iterator getArrowIterator() {
		return moOriginatingArrows.iterator();
	}

	public void remove() throws EXXYError {
		moParent.unregLabel(this);
	}

	///////////////////////////////////////////////////////////////////////

	protected void regOrigArrow(ClArrow oArrow) {
		moOriginatingArrows.add(oArrow);
	}

	protected void regEndArrow(ClArrow oArrow) {
		moEndingArrows.add(oArrow);
	}

	protected void unregOrigArrow(ClArrow oArrow) {
		moOriginatingArrows.remove(oArrow);
	}

	protected void unregEndArrow(ClArrow oArrow) {
		moEndingArrows.remove(oArrow);
	}

}
