package PL;

import util.*;
import DAL.*;

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

class ClLabel extends ClPLObj {
    private static final int HEIGHT = 50;
    private static final int WIDTH  = 50;
    private static final BasicStroke moLblStroke = new BasicStroke(1.0f);
    String mstrLbltxt;

    public ClLabel(Object oLabel){
        moDALObj = oLabel;
        ms8Type = IPL.LABEL;
        mstrLbltxt = "";
    }
    
    public static void setPos(ClPLObj poPLObj, ClCoord kPos){
        try{
            ((ILabel) poPLObj.moDALObj).setPos(kPos);
        }catch(EXXYError e){
            System.out.println(e.toString());
        }
    }
    
    public boolean isLblPos(ClCoord pkPos){
        return pkPos.equals( ((ILabel)moDALObj).getPos());
    }
    
    public boolean equals(ILabel poLabel){
        return (((ILabel) moDALObj) == poLabel);
    }
    
    public static boolean isInNodeArea(ClPLObj poDALObj, Point poPos){
        return isInNodeArea( (ILabel)poDALObj.moDALObj, poPos);
    }
    
    public static boolean isInNodeArea(ILabel oLabel, Point poPos){
        Point gridPos = ClXyWidget.mat2pos( oLabel.getPos() );
        return (
               (poPos.x>(gridPos.x-WIDTH/2)) && (poPos.x<(gridPos.x+WIDTH/2)) &&
                (poPos.y>(gridPos.y-HEIGHT/2)) && (poPos.y<(gridPos.y+HEIGHT/2))
        );
    }
    
    public ClCoord getPos(){
        return ((ILabel) moDALObj).getPos();
    }

    public static ClCoord getPos(ClPLObj poPLObj){
        return ((ILabel) poPLObj.moDALObj).getPos();
    }
    
    public Iterator getArrowIterator(){
        return ((ILabel) moDALObj).getArrowIterator();
    }


/*    public Point getLink2DPos(Point poEndPos){
        Point oStartPos = ClXyWidget.mat2pos( ((ILabel)moDALObj).getPos() );
        return getLink2DPos(oStartPos, poEndPos);
    }
*/
    public static Point getLink2DPos(Point oStartPos, Point poEndPos){
        Point oLinkStartPos = new Point();
        int w = WIDTH/2 + FREESPACE;
        int h = HEIGHT/2 + FREESPACE;
        double a = poEndPos.x-oStartPos.x;
        double b = poEndPos.y-oStartPos.y;
        if(a < 0){
            w = -w;
        }
        if(b < 0){
            h = -h;
        }
        int dw = (int)a;
        if(b != 0) dw = (int)((a/b)*h);
        int dh = (int)b;
        if(a != 0) dh = (int)((b/a)*w);

        if(Math.abs(dw) >= Math.abs(w)){
            oLinkStartPos.y += (oStartPos.y + dh);
            oLinkStartPos.x += (oStartPos.x + w);
        }
        else {
            oLinkStartPos.x += (oStartPos.x + dw);
            oLinkStartPos.y += (oStartPos.y + h);
        }
        return oLinkStartPos;
    }

    public void paint(Graphics g){
        paint((ILabel)moDALObj, g, mbIsSelected, mstrLbltxt);
    }
    
    public static void paint(ILabel poLabel, Graphics g, boolean pbIsSelected, String pstrLbltxt) {
        String strTxt;
        if(pstrLbltxt.length()>6) strTxt = pstrLbltxt.substring(0, 4) + "...";
        else strTxt = pstrLbltxt;
        Graphics2D g2d = (Graphics2D)g;
        Point gridPos = ClXyWidget.mat2pos( poLabel.getPos() );
        g2d.setStroke(moLblStroke);
        g2d.setColor(Color.black);
        g2d.drawRect(gridPos.x - (WIDTH/2), gridPos.y - (HEIGHT/2),
                   WIDTH, HEIGHT);
        if(pbIsSelected){
            g2d.setColor(moSelColor);
        }
        else{
            g2d.setColor(moUnSelColor);
        }
        g2d.fillRect(gridPos.x  - (WIDTH/2) +1, gridPos.y  - (HEIGHT/2) +1,
                   WIDTH-1, HEIGHT-1);
        if(pbIsSelected){
            g2d.setColor(Color.black);
        }
        else{
            g2d.setColor(Color.darkGray);
        }
        g2d.drawString(strTxt,gridPos.x-(WIDTH/2)+5, gridPos.y-(HEIGHT/2)+15 );
    }

    public static void paintOnMove(Graphics g, Point poPoint, Color oColor) {
        Graphics2D g2d = (Graphics2D)g;
        g2d.setStroke(moLblStroke);
        g2d.setColor(oColor);
        g2d.drawRect(poPoint.x - (WIDTH/2), poPoint.y - (HEIGHT/2),
                  WIDTH, HEIGHT);
    }

    public void setText(String pstrTxt){
        mstrLbltxt = pstrTxt;
    }

    public String toString(){
        return mstrLbltxt;
    }
}
