package PL;

import DAL.*;

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import util.*;

public class ClXyWidget extends JPanel implements IPL{

    public static final byte TOOL_POINTER   =   0;
    public static final byte TOOL_LABEL     =   1;
    public static final byte TOOL_ARROW     =   2;

    private IDiagram moDiagram;
    private byte ms8ActualTool;
    private ClPLObj moSelection;
    private JTextField moTxtField;
    private Point moPoint=null;
    private static int mnGrid = 100;
    private ClCoord mkArrBaseBuf;
    private ISelChangedListener moSelListener;
    private boolean mbGridVisible;
    private boolean mbDrag_edit;
    private boolean mbDrag_placeLabel;
    private boolean mbDrag_placeArrow;
    private JScrollPane moScrollPane;
    private static final Dimension preferredSize =
              new Dimension(1024*mnGrid, 1024*mnGrid);

      public ClXyWidget(IDiagram poDiagram, JTextField poTextField) {
        moScrollPane = new JScrollPane(this);
        moScrollPane.setPreferredSize(getPreferredSize());
        moDiagram = poDiagram;
        moTxtField = poTextField;
        moPoint = new Point();
        mbGridVisible = true;
        moSelection = new ClPLObj(null, IPL.NOTHING);

        /*
        ClCoord kTest1 = new ClCoord(1,1);
        ClCoord kTest2 = new ClCoord(1,3);
        ClCoord kTest3 = new ClCoord(2,2);

        try{
            moDiagram.addNewLabel(kTest1);
            moDiagram.addNewLabel(kTest2);
            moDiagram.addNewLabel(kTest3);
            moDiagram.addNewArrow(kTest1, kTest2);
            moDiagram.addNewArrow(kTest1, kTest3);
            moDiagram.addNewArrow(kTest3, kTest2);
        }catch(EXXYError e){
            System.out.println(e.toString());
        }
        */

        moTxtField.addActionListener(
                 new ActionListener(){
                public void actionPerformed(ActionEvent evt) {
                   //moSelNode.setText(moTxtField.getText());
                   repaint();
                }
            }
        );

        addMouseListener(
            new MouseAdapter() {
                public void mouseClicked(MouseEvent e) {
                    //System.out.println("click");
                    switch(ms8ActualTool){
                        case TOOL_POINTER: {
                            select(new Point(e.getX(), e.getY()));
                            break;}
                        case TOOL_LABEL: {
                            //Point matpos = pos2mat(new Point (e()));        tY()));                        //i  //if(matpos!=null) addNode(matpos, ClNodeObj.TYPE_LABEL);
                            break;}
                        case TOOL_ARROW: {
                            break;}
                    }
                //  // System.out.println("x: "+e.getX()+" y: "+e.getY());
                    repaint();
                }

                public void mousePressed(MouseEvent e) {
                    //System.out.println("press");
                    moPoint.x = e.getX();
                    moPoint.y = e.getY();
                    //if(moSelection.getType!=IPL.NOTHING) unselect();
                    if(moSelection!=null) {
                        unselect();
                    }
                    switch(ms8ActualTool){
                        case TOOL_POINTER: {
                            select(new Point(e.getX(), e.getY()));
                            if(moSelection.getType()==IPL.LABEL &&
                                ClLabel.isInNodeArea(moSelection, moPoint)){
                                mbDrag_edit = true;
                            }
                            break;}
                        case TOOL_LABEL: {
                            mbDrag_placeLabel = true;
                            repaint();
                            break;}
                        case TOOL_ARROW: {
                            if(mkArrBaseBuf==null){
                                selectArrowStartNode(new Point (e.getX(), e.getY()));
                            }
                            else{
                                selectArrowEndNode(new Point (e.getX(), e.getY()));
                            }
                            break;}
                    }
                }

                public void mouseReleased(MouseEvent e) {
                    //System.out.println("release");
                    switch(ms8ActualTool){
                        case TOOL_POINTER: {
                            if(moSelection.getType()==IPL.LABEL){
                                ClCoord kPos = pos2mat(new Point(e.getX(), e.getY()));
                                if(kPos!=null && mbDrag_edit && !(isAlreadyInUse(kPos))){
                                    ClLabel.setPos(moSelection, kPos);
                                }
                                repaint();
                                mbDrag_edit = false;
                            }
                        break;}
                        case TOOL_LABEL: {
                            mbDrag_placeLabel = false;
                            ClCoord kPos = pos2mat(new Point (e.getX(), e.getY()));
                            if(kPos!=null) addNode(kPos, IPL.LABEL);
                            repaint();
                            break;}
                        case TOOL_ARROW: {
                            if(mbDrag_placeArrow){
                                if(mkArrBaseBuf!=null){
                                    selectArrowEndNode(new Point (e.getX(), e.getY()));
                                }
                                mbDrag_placeArrow=false;
                                repaint();
                            }
                            break;}
                    }
                }
            }
        );
        addMouseMotionListener(
            new MouseMotionAdapter() {
                public void mouseMoved(MouseEvent e){
                    if(moSelection.getType()==IPL.LABEL){
                        moPoint.x = e.getX();
                        moPoint.y = e.getY();
                        repaint();
                    }
                    if(mkArrBaseBuf!=null){
                        moPoint.x = e.getX();
                        moPoint.y = e.getY();
                        repaint();
                    }
                }

                public void mouseDragged(MouseEvent e) {
                    moPoint.x = e.getX();
                    moPoint.y = e.getY();
                    repaint();
                    if(ms8ActualTool==TOOL_ARROW){
                        if(mkArrBaseBuf!=null) mbDrag_placeArrow=true;
                    }
                }
            }
        );
    }

    public JScrollPane getScrollPane(){
        return moScrollPane;
    }

    public Dimension getPreferredSize() {
        return preferredSize;
    }

    public void setGridSize(int pnGrid){
        mnGrid = pnGrid;
        //preferredSize.setSize(Integer.MAX_VALUE*mnGrid, Integer.MAX_VALUE*mnGrid);
        preferredSize.setSize(5000,5000);
        moScrollPane.setPreferredSize(getPreferredSize());
        repaint();
    }

    public int getGridSize(){
        return mnGrid;
    }

    public void setTool(byte s8Tool) {
        ms8ActualTool = s8Tool;
        switch(s8Tool){
            case TOOL_POINTER: {
                setCursor(new Cursor(Cursor.HAND_CURSOR));
                break; }
            case TOOL_LABEL: {
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                break; }
            case TOOL_ARROW: {
                setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                break; }
            default: {
                System.out.println("Unknown Tool in call to ClXyWidget.setTool(byte s8Tool): "+s8Tool);
                ms8ActualTool = TOOL_POINTER; }
        }
    }


    public static Point mat2pos(ClCoord pkPos){
        Point p = new Point();
        p.x = mnGrid*pkPos.getX();
        p.y = mnGrid*pkPos.getY();
        return p;
    }

    public ClCoord pos2mat(Point poMatPos){
        int xGrid = poMatPos.x;
        int yGrid = poMatPos.y;
        xGrid %= mnGrid;
        yGrid %= mnGrid;
        if(xGrid>(mnGrid/2)){
            xGrid = poMatPos.x - xGrid + mnGrid;
        }
        else{
            xGrid = poMatPos.x - xGrid;
        }
        if(yGrid>(mnGrid/2)){
            yGrid = poMatPos.y - yGrid + mnGrid;
        }
        else{
            yGrid = poMatPos.y - yGrid;
        }
        ClCoord kPos;
        if(xGrid==0 || yGrid==0) kPos = null;
        else kPos = new ClCoord(xGrid/mnGrid, yGrid/mnGrid);
        return kPos;
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);  //paint backgroound
        if(mbGridVisible) paintGrid(g);
        if(mbDrag_edit){
	    for(Iterator iterLbl=moDiagram.getLabelIterator(); iterLbl.hasNext(); ){
	    	ILabel oLabel = (ILabel) iterLbl.next();
                /* paint all Labels espect selected */
		if( !ClLabel.getPos(moSelection).equals(oLabel.getPos()) ){
			ClLabel.paint(oLabel, g, false, oLabel.getCaption());
		}
                for(Iterator iterArr=oLabel.getArrowIterator(); iterArr.hasNext(); ){
                    IArrow oLink = (IArrow) iterArr.next();
                    /* paint all Arrows espect those from and to selected Label */
                    if(moSelection.getType()==IPL.LABEL
                        && !ClArrow.touches(oLink, moSelection)){
                        ClArrow.paint(oLink, g, false);
                    }
                    /* paint "moving" Arrows (those connected with selected Obj)*/
                    else{
                        ClArrow.paintOnMove(oLink, g, moSelection, moPoint, false);
                    }
                }
	    }
            ClCoord kActualPos = pos2mat(moPoint);
            /* paint (moving) selected Label */
            if(kActualPos==null || ( isAlreadyInUse(kActualPos) &&
                !kActualPos.equals(ClLabel.getPos(moSelection)) ) ){
                ClLabel.paintOnMove(g, moPoint, Color.red);
            }
            else {
                ClLabel.paintOnMove(g, moPoint, Color.black);
            }
       }
       else{
	    for(Iterator iterLbl=moDiagram.getLabelIterator(); iterLbl.hasNext(); ){
                ILabel oLabel = ((ILabel) iterLbl.next());
                if(moSelection.getType()==IPL.NOTHING){
                    ClLabel.paint( oLabel, g, false, oLabel.getCaption());
                    /* paint all arrows originated from this label */
                    for(Iterator iterArr=oLabel.getArrowIterator(); iterArr.hasNext(); ){
                        ClArrow.paint( ((IArrow) iterArr.next()), g, false);
                    }
                }
                else if(moSelection.getType()==IPL.LABEL){
                    if(ClLabel.getPos(moSelection).equals(oLabel.getPos()) ){
                        /* paint selected obj */
                        ClLabel.paint( oLabel,g,  true, oLabel.getCaption());
                    }
                    else {
                        /* paint all Objs espect selected */
                        ClLabel.paint( oLabel, g, false, oLabel.getCaption());
                    }
                    /* paint all arrows originated from this label */
                    for(Iterator iterArr=oLabel.getArrowIterator(); iterArr.hasNext(); ){
                        ClArrow.paint( ((IArrow) iterArr.next()), g, false);
                    }
                }
                else if(moSelection.getType()==IPL.ARROW){
                    /* paint label */
                    ClLabel.paint( oLabel, g, false, oLabel.getCaption());
                    for(Iterator iterArr=oLabel.getArrowIterator(); iterArr.hasNext(); ){
                        IArrow oArrow = (IArrow) iterArr.next(); 
                        if(ClArrow.getBasePos(moSelection).equals(oArrow.getBasePos()) &&
                            ClArrow.getTargetPos(moSelection).equals(oArrow.getTargetPos())){
                            /* paint selected arrow */
                            ClArrow.paint(oArrow, g, true);
                        }
                        else{
                            ClArrow.paint(oArrow, g, false);
                        }
                    }
                }
	    }

            if(mbDrag_placeLabel){
                ClCoord kHypothPos = pos2mat(moPoint);
                if(kHypothPos==null || isAlreadyInUse(kHypothPos)){
                    ClLabel.paintOnMove(g, moPoint, Color.red);
                }
                else {
                    ClLabel.paintOnMove(g, moPoint, Color.black);
                }
            }
            else if(mkArrBaseBuf!=null){
                ClCoord kHypothTarget = pos2mat(moPoint);
                if(kHypothTarget!=null && isAlreadyInUse(kHypothTarget)){
                    ClArrow.paintOnMoveNewArrow(g, mkArrBaseBuf, moPoint, Color.black);
                }
                else {
                    ClArrow.paintOnMoveNewArrow(g, mkArrBaseBuf, moPoint, Color.red);
                }
            }
       }
    }

    private ClPLObj getObjAtPos(Point poPos){
        ClPLObj oAtPos = new ClPLObj(null, IPL.NOTHING);
        for(Iterator iterLbl=moDiagram.getLabelIterator(); iterLbl.hasNext(); ){
            ILabel oLabel = (ILabel) iterLbl.next();
            if(ClLabel.isInNodeArea(oLabel, poPos)){
                oAtPos.set(oLabel, IPL.LABEL);
                break;
            }
            for(Iterator iterArr=oLabel.getArrowIterator(); iterArr.hasNext(); ){
                IArrow oArrow = (IArrow) iterArr.next();
                if(ClArrow.isInNodeArea(oArrow, poPos)){
                    oAtPos.set(oArrow, IPL.ARROW);
                    break;
                }
            }
	}
        return oAtPos;
    }

    private void select(Point poPos){
        ClPLObj oLbl = getObjAtPos(poPos);
        oLbl.select();
        moSelection = oLbl;
        if(moSelListener!=null){
            moSelListener.selectionChanged(
                            moSelection.getDALObj(), moSelection.getType());
        }
        if(oLbl.getType()!=IPL.NOTHING){
/*          moTxtField.setBackground(Color.white);
            moTxtField.setEnabled(true);
            moTxtField.setText(moSelection.toString());
 */
        repaint();
        }
    }

    private void selectArrowStartNode(Point poPos){
        ClPLObj oObjToSelect = getObjAtPos(poPos);
        if(oObjToSelect.getType()==IPL.LABEL){
            mkArrBaseBuf = ClLabel.getPos(oObjToSelect);
        }
    }

    private void selectArrowEndNode(Point poPos){
        ClPLObj oObjToSelect = getObjAtPos(poPos);
        if(oObjToSelect.getType()==IPL.LABEL){
            ClCoord kTarget = ClLabel.getPos(oObjToSelect);
            if(kTarget!=null && !mkArrBaseBuf.equals(kTarget));
            {
                IArrow oArrow;
                try{
                    ClCoord kBase = ClLabel.getPos(oObjToSelect);
                    oArrow = moDiagram.addNewArrow(mkArrBaseBuf, kTarget);
                } catch(EXXYError e){
                    System.out.println("If this ever happens something REALLY goes bad...\n");
                }
            }
        }
        mkArrBaseBuf = null;
    }

    private void unselect(){
        if(moSelection!=null){
            moSelection.unselect();
            moSelection.setType(IPL.NOTHING);
            moTxtField.setText("");
            moTxtField.setEnabled(false);
            moTxtField.setBackground(Color.lightGray);
        }
    }

    private void addNode(ClCoord pkPos, byte ps8NodeType){
        switch(ps8NodeType){
            case IPL.LABEL: {
                try{
                    moDiagram.addNewLabel(pkPos);
                } catch(EXXYError e){
                    repaint();
                    JOptionPane.showMessageDialog(
                        getParent(),e.toString(),"Error",JOptionPane.ERROR_MESSAGE);
                }
                break;}
            default:
                break;
        }
    }

    private boolean isAlreadyInUse(ClCoord pkPos){
        boolean bIsUsed=false;
        if(pkPos==null) bIsUsed = true;
        else{
            for(Iterator iterLbl=moDiagram.getLabelIterator(); iterLbl.hasNext() && !bIsUsed; ){
                if( ((ILabel) iterLbl.next()).getPos().equals(pkPos) ) bIsUsed = true;
            }
        }
        return bIsUsed;
    }

    private void paintGrid(Graphics g){
        int xBound = 1024*mnGrid;//getBounds().x;
        int yBound = 1024*mnGrid;//getBounds().y;

        g.setColor(Color.red);
        for(int a=mnGrid/2; a<=xBound; a+=mnGrid){
            g.drawLine(a, mnGrid/2, a, yBound);
            //g.drawLine(a, 0, a, yBound);
        }
        for(int b=mnGrid/2; b<=yBound; b+=mnGrid){
            g.drawLine(mnGrid/2, b, xBound, b);
             //g.drawLine(0, b, xBound, b);
        }
        // dashed area
        /*
        Graphics2D g2 = (Graphics2D) g;
        g2.setColor(new Color(100,70,0));
        float[] f = {10.0f};
        //BasicStroke oDashed = new BasicStroke(1.0f,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f, f, 0.0f);
        //g2.setStroke(oDashed);
        for(int a=mnGrid/2; a<=xBound; a+=mnGrid){
            g2.drawLine(a, mnGrid/2, a, yBound);
        }
        for(int b=mnGrid/2; b<=yBound; b+=mnGrid){
            g2.drawLine(mnGrid/2, b, xBound, b);
        }
        */
    }

    public void deleteSelected() {
        try{
            moSelection.remove();
        } catch(EXXYError e){
            System.out.println(e.toString());
        }
    }

    public void setGridVisible(boolean pbGridVisibility) {
        mbGridVisible = pbGridVisibility;
        repaint();
    }

    public void setSelChangedListener(ISelChangedListener poSelListener) {
        moSelListener = poSelListener;
    }

}
