// XY_GUI_Menu.java
//
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class XY_GUI_Menu extends JMenuBar {

   static final String[ ] fileItems = new String[ ] { "Neues Diagramm", "ffnen", "Speichern", "Beenden" };
   static final String[ ] editItems = new String[ ] { "Rckgngig", "Ausschneiden", "Kopieren", "Einfgen" };
   static final String[ ] toolItems = new String[ ] { "Pointer","Label-Tool", "Arrow-Tool", "Change Grid" };

   static final char[ ] fileShortcuts = { 'N','','s','e' };
   static final char[ ] editShortcuts = { 'U','X','C','V' };
   static final char[ ] toolShortcuts = { 'P','L','A', 'G' };

   public XY_GUI_Menu( ActionListener oListener ) {

      JMenu fileMenu = new JMenu("Datei");
      JMenu editMenu = new JMenu("Bearbeiten");
      JMenu toolMenu = new JMenu("Tools");

      // Assemble the File menu shortcuts
      for (int i=0; i < fileItems.length; i++) {
         JMenuItem item = new JMenuItem(fileItems[i], fileShortcuts[i]);
         item.addActionListener(oListener);
         fileMenu.add(item);
      }

      // Assemble the Edit and Tool menus with keyboard accelerators.
      for (int i=0; i < editItems.length; i++) {
         JMenuItem itemEdit = new JMenuItem(editItems[i]);
         itemEdit.setAccelerator(KeyStroke.getKeyStroke(editShortcuts[i],
              Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
         itemEdit.addActionListener(oListener);
         editMenu.add(itemEdit);
      }
      for (int i=0; i < toolItems.length; i++) {
         JMenuItem toolEdit = new JMenuItem(toolItems[i]);
         toolEdit.setAccelerator(KeyStroke.getKeyStroke(toolShortcuts[i],
              Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
         toolEdit.addActionListener(oListener);
         toolMenu.add(toolEdit);
      }

      // Insert a separator in the Edit menu in Position 1 after "Undo".
      editMenu.insertSeparator(1);

      // Finally, add all the menus to the menu bar.
      add(fileMenu);
      add(editMenu);
      add(toolMenu);
   }
}
