import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

 // import java.beans.*; // for PropertyVetoException, thrown by JInternalFrame

 class XY_MainGUI
 extends JFrame
 {
   //private JDesktopPane desk;
   private int nChildFrameCnt;
   private ClXyWidget moWidget;

   public XY_MainGUI()
   {
     super("XY-Pic Proto v0.1");
     nChildFrameCnt = 0;
     JTextField textField = new JTextField();
     moWidget = new ClXyWidget(textField);

     JScrollPane scrollPane = new JScrollPane(moWidget);
     scrollPane.setPreferredSize(new Dimension(500,350));

        GridBagLayout gridBag = new GridBagLayout();
        Container contentPane = getContentPane();
        contentPane.setLayout(gridBag);
        GridBagConstraints c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;

        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1.0;
        c.weighty = 3.0;
        gridBag.setConstraints(scrollPane, c);
        contentPane.add(scrollPane);
     
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1.0;
        c.weighty = 1.0;
        gridBag.setConstraints(textField, c);
        contentPane.add(textField);
        textField.setBackground(Color.lightGray);
        textField.setEnabled(false);

          //setContentPane(scrolllPane);
     
     ActionListener oListener = new XY_MenuListener(this);
     JMenuBar oMenuBar = new XY_GUI_Menu(oListener);
     setJMenuBar(oMenuBar);
     addWindowListener(new WindowClosingAdapter(true));
   }

   public void addChild()
   {
     JInternalFrame child = new XY_MatrixGUI((new Integer(++nChildFrameCnt)).toString());
     child.setLocation(10, 10);
     child.setSize(200, 150);
     child.setDefaultCloseOperation(
       JInternalFrame.DISPOSE_ON_CLOSE
     );
     getContentPane().add(child);
     try{
        child.setMaximum(true);
     } catch(Exception e){
        System.out.println("Error Mamimizing child-frame!");
     }
     child.setVisible(true);
   }
   
   public void open()
   {
        try{
            FileDialog oDialog = new FileDialog(this,"Diagramm ffnen", FileDialog.LOAD);
            oDialog.show();
        } catch(Exception e){System.out.println("Fehler!Fehler beim ffnen der Datei: " + e.toString());}
   }
   
   public void close()
   {
       setVisible(false);
       dispose();
       System.exit(0);
   }
   
   public void setTool(byte s8Tool){
        moWidget.setTool(s8Tool);
   }
   
   public void gridDialog(){
        JDialog dialog = new JDialog(this, "Change Grid");

        dialog.setSize(new Dimension(300, 150));
        int gridPos = moWidget.getGrid();
        JSlider oVertGridSlider = new JSlider(JSlider.HORIZONTAL, 50, 200, gridPos);
        oVertGridSlider.addChangeListener(
            new ChangeListener() {
                public void stateChanged(ChangeEvent e) {
                    JSlider source = (JSlider)e.getSource();
                   if (!source.getValueIsAdjusting()) {
                        int slideVal = (int)source.getValue();
                        moWidget.setGrid(slideVal);
                    }
                }
            }
        );
        oVertGridSlider.setMajorTickSpacing(25);
        oVertGridSlider.setMinorTickSpacing(5);
        oVertGridSlider.setPaintTicks(true);
        oVertGridSlider.setPaintLabels(true);
        oVertGridSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
        
        JButton oOkButton = new JButton("Ok");
        oOkButton.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    moWidget.repaint();
                }
            }
        );
        oOkButton.setBounds(20,20,20,15);

        dialog.getContentPane().add(oOkButton);
        dialog.getContentPane().add(oVertGridSlider, BorderLayout.SOUTH);
        dialog.setLocationRelativeTo(this);
        dialog.setVisible(true);
   }
 }
