/** Start up class.
 *  Only parses the commandline and instantiates ClXxy.
 *
 *  @author Vitus Lorenz-Meyer
 *  @version 1.0 $Rev: 250 $
 */

import Control.*;
import java.util.*;

public abstract class run{
	/** Help String */
	private static final String mstrHelp = "Usage: java Xxy [options] [files]\n\nwhere options include:\n\t-nosplash\tdon't display splash screen\n\t-h,--help\tthis help";

	/** main method to start the application
	 *  @param args - String Array with arguments */
	public static void main(String[] args) {
			int i;
			boolean mbNoSlpash = false;

			if (args.length > 0){
				Arrays.sort(args);
				if ( (Arrays.binarySearch(args,"-h")>=0) ||
				     (Arrays.binarySearch(args,"--help")) >=0 ){
						//only print the help text and exit
						System.out.println(ClXxy.mstrVersion+"\n"+mstrHelp);
						System.exit(0);
				}
				if ( (i=Arrays.binarySearch(args,"-nosplash")) >= 0){
					//disable splash screen
					mbNoSlpash=true;
					args[i]=null;
				}

			}
			//start the app
			ClXxy x = new ClXxy(mbNoSlpash,args);

	}
}
